package sun.font;

import java.awt.geom.GeneralPath;
import java.awt.geom.Rectangle2D;
import java.awt.geom.Point2D;
import java.awt.FontFormatException;

public abstract class PhysicalFont extends Font2D
{
    protected String platName;
    protected Object nativeNames;
    
    @Override
    public boolean equals(Object o) {
        return o != null && o.getClass() == this.getClass() && ((Font2D)o).fullName.equals(this.fullName);
    }
    
    @Override
    public int hashCode() {
        return this.fullName.hashCode();
    }
    
    PhysicalFont(String platName, Object nativeNames) throws FontFormatException {
        this.handle = new Font2DHandle(this);
        this.platName = platName;
        this.nativeNames = nativeNames;
    }
    
    protected PhysicalFont() {
        this.handle = new Font2DHandle(this);
    }
    
    Point2D.Float getGlyphPoint(long n, int n2, int n3) {
        return new Point2D.Float();
    }
    
    abstract StrikeMetrics getFontMetrics(long p0);
    
    abstract float getGlyphAdvance(long p0, int p1);
    
    abstract void getGlyphMetrics(long p0, int p1, Point2D.Float p2);
    
    abstract long getGlyphImage(long p0, int p1);
    
    abstract Rectangle2D.Float getGlyphOutlineBounds(long p0, int p1);
    
    abstract GeneralPath getGlyphOutline(long p0, int p1, float p2, float p3);
    
    abstract GeneralPath getGlyphVectorOutline(long p0, int[] p1, int p2, float p3, float p4);
}
